/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package FunctionLayer.misc;

import edu.cmu.lti.lexical_db.ILexicalDatabase;
import edu.cmu.lti.lexical_db.NictWordNet;
import edu.cmu.lti.ws4j.RelatednessCalculator;
import edu.cmu.lti.ws4j.impl.HirstStOnge;
import edu.cmu.lti.ws4j.impl.JiangConrath;
import edu.cmu.lti.ws4j.impl.LeacockChodorow;
import edu.cmu.lti.ws4j.impl.Lesk;
import edu.cmu.lti.ws4j.impl.Lin;
import edu.cmu.lti.ws4j.impl.Path;
import edu.cmu.lti.ws4j.impl.Resnik;
import edu.cmu.lti.ws4j.impl.WuPalmer;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author install1
 * http://ws4jdemo.appspot.com/?mode=s&s1=something+like+a+sentence&s2=should+not+be+like+the+first+one
 */
public class WordNetSimalarityTestObsolete {

    private static ILexicalDatabase db = new NictWordNet();
    private static RelatednessCalculator rc1 = new WuPalmer(db);
    private static RelatednessCalculator rc2 = new Resnik(db);
    private static RelatednessCalculator rc3 = new JiangConrath(db);
    private static RelatednessCalculator rc4 = new Lin(db);
    private static RelatednessCalculator rc5 = new LeacockChodorow(db);
    private static RelatednessCalculator rc6 = new Path(db);
    private static RelatednessCalculator rc7 = new Lesk(db);
    private static RelatednessCalculator rc8 = new HirstStOnge(db);

    public static double SentenceMatcherSimilarityMatrix(String[] words1, String[] words2, double maxScore) {
        boolean initial = maxScore == 0.0;
        List<RelatednessCalculator> RCList = new ArrayList();
        RCList.add(rc1);
        RCList.add(rc2);
        RCList.add(rc3);
        RCList.add(rc4);
        RCList.add(rc5);
        RCList.add(rc6);
        RCList.add(rc7);
        RCList.add(rc8);
        for (int h = 0; h < RCList.size(); h++) {
            double s1 = getSimilarityMatrix(words1, words2, RCList.get(h), maxScore, initial);
            System.out.println("s1: " + String.format("%.0f", s1) + " \nmaxScore: " + maxScore);
            if (s1 > 0.01 && (s1 < maxScore || initial)) {
                maxScore = s1;
            }
        }
        return maxScore;
    }

    public static double getSimilarityMatrix(String[] words1, String[] words2, RelatednessCalculator rc, double maxScore, boolean initial) {
        double rtndouble = 0.01;
        for (int i = 0; i < words1.length; i++) {
            for (int j = 0; j < words2.length; j++) {
                if (maxScore > rtndouble / words2.length || initial) {
                    rtndouble += (rc.calcRelatednessOfWords(words1[i], words2[j]));
                    //System.out.println("RelatednessCalculator: " + rc.toString());
                } else {
                    return rtndouble;
                }
            }
        }
        return rtndouble;
    }
}
